<?php



namespace Orbipay\PaymentsApi\Client\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;

/**
 * Warning:
 *
 * <p><font color="red"> This class subject to change without prior notice, Please dont use this class directly. </font></p>


 *
 * @category Class
 * @description The customer&#39;s funding account with which the payment is being made.
 * @package  Orbipay\PaymentsApi\Client\Model
 */
class FundingAccountSnapshotResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'FundingAccountSnapshotResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'string',
        'url' => 'string',
        'account_number' => 'string',
        'account_type' => 'string',
        'account_subtype' => 'string',
        'aba_routing_number' => 'string',
        'issuer_name' => 'string',
        'nickname' => 'string',
        'display_text' => 'string',
        'account_holder_name' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'id' => null,
        'url' => null,
        'account_number' => null,
        'account_type' => null,
        'account_subtype' => null,
        'aba_routing_number' => null,
        'issuer_name' => null,
        'nickname' => null,
        'display_text' => null,
        'account_holder_name' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'url' => 'url',
        'account_number' => 'account_number',
        'account_type' => 'account_type',
        'account_subtype' => 'account_subtype',
        'aba_routing_number' => 'aba_routing_number',
        'issuer_name' => 'issuer_name',
        'nickname' => 'nickname',
        'display_text' => 'display_text',
        'account_holder_name' => 'account_holder_name'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'url' => 'setUrl',
        'account_number' => 'setAccountNumber',
        'account_type' => 'setAccountType',
        'account_subtype' => 'setAccountSubtype',
        'aba_routing_number' => 'setAbaRoutingNumber',
        'issuer_name' => 'setIssuerName',
        'nickname' => 'setNickname',
        'display_text' => 'setDisplayText',
        'account_holder_name' => 'setAccountHolderName'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'url' => 'getUrl',
        'account_number' => 'getAccountNumber',
        'account_type' => 'getAccountType',
        'account_subtype' => 'getAccountSubtype',
        'aba_routing_number' => 'getAbaRoutingNumber',
        'issuer_name' => 'getIssuerName',
        'nickname' => 'getNickname',
        'display_text' => 'getDisplayText',
        'account_holder_name' => 'getAccountHolderName'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const ACCOUNT_TYPE_BANK = 'bank';
    const ACCOUNT_TYPE_DEBIT_CARD = 'debit_card';
    const ACCOUNT_TYPE_CREDIT_CARD = 'credit_card';
    const ACCOUNT_TYPE_WALLET = 'wallet';
    const ACCOUNT_SUBTYPE_SAVINGS = 'savings';
    const ACCOUNT_SUBTYPE_CHECKING = 'checking';
    const ACCOUNT_SUBTYPE_MONEY_MARKET = 'money_market';
    const ACCOUNT_SUBTYPE_VISA_CREDIT = 'visa_credit';
    const ACCOUNT_SUBTYPE_MASTERCARD_CREDIT = 'mastercard_credit';
    const ACCOUNT_SUBTYPE_AMERICAN_EXPRESS_CREDIT = 'american_express_credit';
    const ACCOUNT_SUBTYPE_DISCOVER_CREDIT = 'discover_credit';
    const ACCOUNT_SUBTYPE_VISA_DEBIT = 'visa_debit';
    const ACCOUNT_SUBTYPE_MASTERCARD_DEBIT = 'mastercard_debit';
    const ACCOUNT_SUBTYPE_DISCOVER_DEBIT = 'discover_debit';
    const ACCOUNT_SUBTYPE_APPLE_PAY = 'apple_pay';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAccountTypeAllowableValues()
    {
        return [
            self::ACCOUNT_TYPE_BANK,
            self::ACCOUNT_TYPE_DEBIT_CARD,
            self::ACCOUNT_TYPE_CREDIT_CARD,
            self::ACCOUNT_TYPE_WALLET,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAccountSubtypeAllowableValues()
    {
        return [
            self::ACCOUNT_SUBTYPE_SAVINGS,
            self::ACCOUNT_SUBTYPE_CHECKING,
            self::ACCOUNT_SUBTYPE_MONEY_MARKET,
            self::ACCOUNT_SUBTYPE_VISA_CREDIT,
            self::ACCOUNT_SUBTYPE_MASTERCARD_CREDIT,
            self::ACCOUNT_SUBTYPE_AMERICAN_EXPRESS_CREDIT,
            self::ACCOUNT_SUBTYPE_DISCOVER_CREDIT,
            self::ACCOUNT_SUBTYPE_VISA_DEBIT,
            self::ACCOUNT_SUBTYPE_MASTERCARD_DEBIT,
            self::ACCOUNT_SUBTYPE_DISCOVER_DEBIT,
            self::ACCOUNT_SUBTYPE_APPLE_PAY,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['account_number'] = isset($data['account_number']) ? $data['account_number'] : null;
        $this->container['account_type'] = isset($data['account_type']) ? $data['account_type'] : null;
        $this->container['account_subtype'] = isset($data['account_subtype']) ? $data['account_subtype'] : null;
        $this->container['aba_routing_number'] = isset($data['aba_routing_number']) ? $data['aba_routing_number'] : null;
        $this->container['issuer_name'] = isset($data['issuer_name']) ? $data['issuer_name'] : null;
        $this->container['nickname'] = isset($data['nickname']) ? $data['nickname'] : null;
        $this->container['display_text'] = isset($data['display_text']) ? $data['display_text'] : null;
        $this->container['account_holder_name'] = isset($data['account_holder_name']) ? $data['account_holder_name'] : null;
    }


    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id Id is a unique identifier assigned to the account in EBPP.
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url This URL fetches the funding account details.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets account_number
     *
     * @return string
     */
    public function getAccountNumber()
    {
        return $this->container['account_number'];
    }

    /**
     * Sets account_number
     *
     * @param string $account_number The number or reference that a customer uses to identify the funding account. In case of Apple Pay, this is the device-specific account number of the card.
     *
     * @return $this
     */
    public function setAccountNumber($account_number)
    {
        $this->container['account_number'] = $account_number;

        return $this;
    }

    /**
     * Gets account_type
     *
     * @return string
     */
    public function getAccountType()
    {
        return $this->container['account_type'];
    }

    /**
     * Sets account_type
     *
     * @param string $account_type The type of the funding account.
     *
     * @return $this
     */
    public function setAccountType($account_type)
    {
        $this->container['account_type'] = $account_type;

        return $this;
    }

    /**
     * Gets account_subtype
     *
     * @return string
     */
    public function getAccountSubtype()
    {
        return $this->container['account_subtype'];
    }

    /**
     * Sets account_subtype
     *
     * @param string $account_subtype The sub type of the funding account. This is derived by EBPP in the case of card funding accounts. It needs to be passed when adding or editing a DDA/Bank/ApplePay account.
     *
     * @return $this
     */
    public function setAccountSubtype($account_subtype)
    {
        $this->container['account_subtype'] = $account_subtype;

        return $this;
    }

    /**
     * Gets aba_routing_number
     *
     * @return string
     */
    public function getAbaRoutingNumber()
    {
        return $this->container['aba_routing_number'];
    }

    /**
     * Sets aba_routing_number
     *
     * @param string $aba_routing_number The ABA/Routing number for the bank account.
     *
     * @return $this
     */
    public function setAbaRoutingNumber($aba_routing_number)
    {
        $this->container['aba_routing_number'] = $aba_routing_number;

        return $this;
    }

    /**
     * Gets issuer_name
     *
     * @return string
     */
    public function getIssuerName()
    {
        return $this->container['issuer_name'];
    }

    /**
     * Sets issuer_name
     *
     * @param string $issuer_name The name of the authority that has issued the account. This is relevant only in the case of bank accounts.
     *
     * @return $this
     */
    public function setIssuerName($issuer_name)
    {
        $this->container['issuer_name'] = $issuer_name;

        return $this;
    }

    /**
     * Gets nickname
     *
     * @return string
     */
    public function getNickname()
    {
        return $this->container['nickname'];
    }

    /**
     * Sets nickname
     *
     * @param string $nickname The nickname by which a customer might want to identify the account.
     *
     * @return $this
     */
    public function setNickname($nickname)
    {
        $this->container['nickname'] = $nickname;

        return $this;
    }

    /**
     * Gets display_text
     *
     * @return string
     */
    public function getDisplayText()
    {
        return $this->container['display_text'];
    }

    /**
     * Sets display_text
     *
     * @param string $display_text UI representation of the account.
     *
     * @return $this
     */
    public function setDisplayText($display_text)
    {
        $this->container['display_text'] = $display_text;

        return $this;
    }

    /**
     * Gets account_holder_name
     *
     * @return string
     */
    public function getAccountHolderName()
    {
        return $this->container['account_holder_name'];
    }

    /**
     * Sets account_holder_name
     *
     * @param string $account_holder_name The name as specified on the account.
     *
     * @return $this
     */
    public function setAccountHolderName($account_holder_name)
    {
        $this->container['account_holder_name'] = $account_holder_name;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


