<?php



namespace Orbipay\PaymentsApi\Client\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;

/**
 * Warning:
 *
 * <p><font color="red"> This class subject to change without prior notice, Please dont use this class directly. </font></p>


 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Model
 */
class SimplePaymentResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'SimplePaymentResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'string',
        'url' => 'string',
        'fee' => '\Orbipay\PaymentsApi\Client\Model\FeeResponse',
        'status' => 'string',
        'payment_method' => 'string',
        'confirmation_number' => 'string',
        'custom_fields' => 'map[string,string]',
        'currency_code3d' => 'string',
        'amount' => 'string',
        'card_cvv_number' => 'string',
        'payment_date' => 'string',
        'payment_schedule_type' => 'string',
        'payment_request_date' => 'string',
        'payment_amount_type' => 'string',
        'payment_reference' => 'string',
        'expected_payment_settlement_date' => 'string',
        'payment_entry_date' => 'string',
        'payment_return_date' => 'string',
        'return_code' => 'string',
        'payment_notification_email' => 'string',
        'comments' => 'string',
        'customer' => '\Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerResponse',
        'funding_account' => '\Orbipay\PaymentsApi\Client\Model\FundingAccountResponse',
        'customer_account' => '\Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse',
        'payment_network_response' => '\Orbipay\PaymentsApi\Client\Model\PaymentNetworkResponseVo',
        'audit_info' => '\Orbipay\PaymentsApi\Client\Model\AuditInfoVo'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'id' => null,
        'url' => null,
        'fee' => null,
        'status' => null,
        'payment_method' => null,
        'confirmation_number' => null,
        'custom_fields' => null,
        'currency_code3d' => null,
        'amount' => null,
        'card_cvv_number' => null,
        'payment_date' => null,
        'payment_schedule_type' => null,
        'payment_request_date' => null,
        'payment_amount_type' => null,
        'payment_reference' => null,
        'expected_payment_settlement_date' => null,
        'payment_entry_date' => null,
        'payment_return_date' => null,
        'return_code' => null,
        'payment_notification_email' => 'email',
        'comments' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'payment_network_response' => null,
        'audit_info' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'url' => 'url',
        'fee' => 'fee',
        'status' => 'status',
        'payment_method' => 'payment_method',
        'confirmation_number' => 'confirmation_number',
        'custom_fields' => 'custom_fields',
        'currency_code3d' => 'currency_code3d',
        'amount' => 'amount',
        'card_cvv_number' => 'card_cvv_number',
        'payment_date' => 'payment_date',
        'payment_schedule_type' => 'payment_schedule_type',
        'payment_request_date' => 'payment_request_date',
        'payment_amount_type' => 'payment_amount_type',
        'payment_reference' => 'payment_reference',
        'expected_payment_settlement_date' => 'expected_payment_settlement_date',
        'payment_entry_date' => 'payment_entry_date',
        'payment_return_date' => 'payment_return_date',
        'return_code' => 'return_code',
        'payment_notification_email' => 'payment_notification_email',
        'comments' => 'comments',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'payment_network_response' => 'payment_network_response',
        'audit_info' => 'audit_info'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'url' => 'setUrl',
        'fee' => 'setFee',
        'status' => 'setStatus',
        'payment_method' => 'setPaymentMethod',
        'confirmation_number' => 'setConfirmationNumber',
        'custom_fields' => 'setCustomFields',
        'currency_code3d' => 'setCurrencyCode3d',
        'amount' => 'setAmount',
        'card_cvv_number' => 'setCardCvvNumber',
        'payment_date' => 'setPaymentDate',
        'payment_schedule_type' => 'setPaymentScheduleType',
        'payment_request_date' => 'setPaymentRequestDate',
        'payment_amount_type' => 'setPaymentAmountType',
        'payment_reference' => 'setPaymentReference',
        'expected_payment_settlement_date' => 'setExpectedPaymentSettlementDate',
        'payment_entry_date' => 'setPaymentEntryDate',
        'payment_return_date' => 'setPaymentReturnDate',
        'return_code' => 'setReturnCode',
        'payment_notification_email' => 'setPaymentNotificationEmail',
        'comments' => 'setComments',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'payment_network_response' => 'setPaymentNetworkResponse',
        'audit_info' => 'setAuditInfo'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'url' => 'getUrl',
        'fee' => 'getFee',
        'status' => 'getStatus',
        'payment_method' => 'getPaymentMethod',
        'confirmation_number' => 'getConfirmationNumber',
        'custom_fields' => 'getCustomFields',
        'currency_code3d' => 'getCurrencyCode3d',
        'amount' => 'getAmount',
        'card_cvv_number' => 'getCardCvvNumber',
        'payment_date' => 'getPaymentDate',
        'payment_schedule_type' => 'getPaymentScheduleType',
        'payment_request_date' => 'getPaymentRequestDate',
        'payment_amount_type' => 'getPaymentAmountType',
        'payment_reference' => 'getPaymentReference',
        'expected_payment_settlement_date' => 'getExpectedPaymentSettlementDate',
        'payment_entry_date' => 'getPaymentEntryDate',
        'payment_return_date' => 'getPaymentReturnDate',
        'return_code' => 'getReturnCode',
        'payment_notification_email' => 'getPaymentNotificationEmail',
        'comments' => 'getComments',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'payment_network_response' => 'getPaymentNetworkResponse',
        'audit_info' => 'getAuditInfo'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const STATUS_SCHEDULED = 'scheduled';
    const STATUS_CANCELLED = 'cancelled';
    const STATUS_PROCESSING = 'processing';
    const STATUS_PROCESSED = 'processed';
    const STATUS_RETURNED = 'returned';
    const STATUS_DECLINED = 'declined';
    const STATUS_DISPUTED = 'disputed';
    const STATUS_ERROR = 'error';
    const PAYMENT_METHOD_ACH = 'ach';
    const PAYMENT_METHOD_CHECK = 'check';
    const PAYMENT_METHOD_VISA_DEBIT = 'visa_debit';
    const PAYMENT_METHOD_PINLESS_DEBIT = 'pinless_debit';
    const PAYMENT_METHOD_MASTER_DEBIT = 'master_debit';
    const PAYMENT_METHOD_AMEX_CREDIT = 'amex_credit';
    const PAYMENT_METHOD_DISCOVER_CREDIT = 'discover_credit';
    const PAYMENT_METHOD_VISA_CREDIT = 'visa_credit';
    const PAYMENT_METHOD_MASTER_CREDIT = 'master_credit';
    const PAYMENT_METHOD_CASH = 'cash';
    const PAYMENT_METHOD_DISCOVER_DEBIT = 'discover_debit';
    const PAYMENT_METHOD_APPLE_PAY = 'apple_pay';
    const PAYMENT_SCHEDULE_TYPE_ONE_TIME_PAYMENT = 'one_time_payment';
    const PAYMENT_SCHEDULE_TYPE_AUTOPAY_GENERATED_PAYMENT = 'autopay_generated_payment';
    const PAYMENT_SCHEDULE_TYPE_VARIABLE_RECURRING_GENERATED_PAYMENT = 'variable_recurring_generated_payment';
    const PAYMENT_SCHEDULE_TYPE_PAYMENT_PLAN_GENERATED = 'payment_plan_generated';
    const PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE = 'current_balance';
    const PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE = 'minimum_payment_due';
    const PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE = 'past_payment_due';
    const PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE = 'statement_balance';
    const PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT = 'discounted_amount';
    const PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT = 'penalty_amount';
    const PAYMENT_AMOUNT_TYPE_OTHER = 'other';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_SCHEDULED,
            self::STATUS_CANCELLED,
            self::STATUS_PROCESSING,
            self::STATUS_PROCESSED,
            self::STATUS_RETURNED,
            self::STATUS_DECLINED,
            self::STATUS_DISPUTED,
            self::STATUS_ERROR,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentMethodAllowableValues()
    {
        return [
            self::PAYMENT_METHOD_ACH,
            self::PAYMENT_METHOD_CHECK,
            self::PAYMENT_METHOD_VISA_DEBIT,
            self::PAYMENT_METHOD_PINLESS_DEBIT,
            self::PAYMENT_METHOD_MASTER_DEBIT,
            self::PAYMENT_METHOD_AMEX_CREDIT,
            self::PAYMENT_METHOD_DISCOVER_CREDIT,
            self::PAYMENT_METHOD_VISA_CREDIT,
            self::PAYMENT_METHOD_MASTER_CREDIT,
            self::PAYMENT_METHOD_CASH,
            self::PAYMENT_METHOD_DISCOVER_DEBIT,
            self::PAYMENT_METHOD_APPLE_PAY,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentScheduleTypeAllowableValues()
    {
        return [
            self::PAYMENT_SCHEDULE_TYPE_ONE_TIME_PAYMENT,
            self::PAYMENT_SCHEDULE_TYPE_AUTOPAY_GENERATED_PAYMENT,
            self::PAYMENT_SCHEDULE_TYPE_VARIABLE_RECURRING_GENERATED_PAYMENT,
            self::PAYMENT_SCHEDULE_TYPE_PAYMENT_PLAN_GENERATED,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentAmountTypeAllowableValues()
    {
        return [
            self::PAYMENT_AMOUNT_TYPE_CURRENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_MINIMUM_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_PAST_PAYMENT_DUE,
            self::PAYMENT_AMOUNT_TYPE_STATEMENT_BALANCE,
            self::PAYMENT_AMOUNT_TYPE_DISCOUNTED_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_PENALTY_AMOUNT,
            self::PAYMENT_AMOUNT_TYPE_OTHER,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['fee'] = isset($data['fee']) ? $data['fee'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['payment_method'] = isset($data['payment_method']) ? $data['payment_method'] : null;
        $this->container['confirmation_number'] = isset($data['confirmation_number']) ? $data['confirmation_number'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
        $this->container['currency_code3d'] = isset($data['currency_code3d']) ? $data['currency_code3d'] : null;
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['card_cvv_number'] = isset($data['card_cvv_number']) ? $data['card_cvv_number'] : null;
        $this->container['payment_date'] = isset($data['payment_date']) ? $data['payment_date'] : null;
        $this->container['payment_schedule_type'] = isset($data['payment_schedule_type']) ? $data['payment_schedule_type'] : null;
        $this->container['payment_request_date'] = isset($data['payment_request_date']) ? $data['payment_request_date'] : null;
        $this->container['payment_amount_type'] = isset($data['payment_amount_type']) ? $data['payment_amount_type'] : null;
        $this->container['payment_reference'] = isset($data['payment_reference']) ? $data['payment_reference'] : null;
        $this->container['expected_payment_settlement_date'] = isset($data['expected_payment_settlement_date']) ? $data['expected_payment_settlement_date'] : null;
        $this->container['payment_entry_date'] = isset($data['payment_entry_date']) ? $data['payment_entry_date'] : null;
        $this->container['payment_return_date'] = isset($data['payment_return_date']) ? $data['payment_return_date'] : null;
        $this->container['return_code'] = isset($data['return_code']) ? $data['return_code'] : null;
        $this->container['payment_notification_email'] = isset($data['payment_notification_email']) ? $data['payment_notification_email'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['customer'] = isset($data['customer']) ? $data['customer'] : null;
        $this->container['funding_account'] = isset($data['funding_account']) ? $data['funding_account'] : null;
        $this->container['customer_account'] = isset($data['customer_account']) ? $data['customer_account'] : null;
        $this->container['payment_network_response'] = isset($data['payment_network_response']) ? $data['payment_network_response'] : null;
        $this->container['audit_info'] = isset($data['audit_info']) ? $data['audit_info'] : null;
    }


    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id The unique identifier assigned by EBPP to the payment.
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url This URL fetches the details of payment.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets fee
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FeeResponse
     */
    public function getFee()
    {
        return $this->container['fee'];
    }

    /**
     * Sets fee
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FeeResponse $fee fee
     *
     * @return $this
     */
    public function setFee($fee)
    {
        $this->container['fee'] = $fee;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status The status of the payment.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets payment_method
     *
     * @return string
     */
    public function getPaymentMethod()
    {
        return $this->container['payment_method'];
    }

    /**
     * Sets payment_method
     *
     * @param string $payment_method The fulfillment method for the payment.
     *
     * @return $this
     */
    public function setPaymentMethod($payment_method)
    {
        $this->container['payment_method'] = $payment_method;

        return $this;
    }

    /**
     * Gets confirmation_number
     *
     * @return string
     */
    public function getConfirmationNumber()
    {
        return $this->container['confirmation_number'];
    }

    /**
     * Sets confirmation_number
     *
     * @param string $confirmation_number The confirmation number or reference provided to the customer for the payment.
     *
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        $this->container['confirmation_number'] = $confirmation_number;

        return $this;
    }

    /**
     * Gets custom_fields
     *
     * @return map[string,string]
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     *
     * @param map[string,string] $custom_fields The additional information or meta-information that EBPP can accept, maintain and transmit back to the client. The custom fields need to be configured with EBPP before they can be accepted. EBPP would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.
     *
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Gets currency_code3d
     *
     * @return string
     */
    public function getCurrencyCode3d()
    {
        return $this->container['currency_code3d'];
    }

    /**
     * Sets currency_code3d
     *
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by EBPP. This defaults to USD.
     *
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->container['currency_code3d'] = $currency_code3d;

        return $this;
    }

    /**
     * Gets amount
     *
     * @return string
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     *
     * @param string $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     *
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets card_cvv_number
     *
     * @return string
     */
    public function getCardCvvNumber()
    {
        return $this->container['card_cvv_number'];
    }

    /**
     * Sets card_cvv_number
     *
     * @param string $card_cvv_number This is never returned by EBPP. This needs to be passed to EBPP when making or editing a payment with a card funding account.
     *
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->container['card_cvv_number'] = $card_cvv_number;

        return $this;
    }

    /**
     * Gets payment_date
     *
     * @return string
     */
    public function getPaymentDate()
    {
        return $this->container['payment_date'];
    }

    /**
     * Sets payment_date
     *
     * @param string $payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentDate($payment_date)
    {
        $this->container['payment_date'] = $payment_date;

        return $this;
    }

    /**
     * Gets payment_schedule_type
     *
     * @return string
     */
    public function getPaymentScheduleType()
    {
        return $this->container['payment_schedule_type'];
    }

    /**
     * Sets payment_schedule_type
     *
     * @param string $payment_schedule_type The schedule type for the payment. This defaults to one_time_payment.
     *
     * @return $this
     */
    public function setPaymentScheduleType($payment_schedule_type)
    {
        $this->container['payment_schedule_type'] = $payment_schedule_type;

        return $this;
    }

    /**
     * Gets payment_request_date
     *
     * @return string
     */
    public function getPaymentRequestDate()
    {
        return $this->container['payment_request_date'];
    }

    /**
     * Sets payment_request_date
     *
     * @param string $payment_request_date The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD. This is applicable only if the client has opted for it.
     *
     * @return $this
     */
    public function setPaymentRequestDate($payment_request_date)
    {
        $this->container['payment_request_date'] = $payment_request_date;

        return $this;
    }

    /**
     * Gets payment_amount_type
     *
     * @return string
     */
    public function getPaymentAmountType()
    {
        return $this->container['payment_amount_type'];
    }

    /**
     * Sets payment_amount_type
     *
     * @param string $payment_amount_type The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.
     *
     * @return $this
     */
    public function setPaymentAmountType($payment_amount_type)
    {
        $this->container['payment_amount_type'] = $payment_amount_type;

        return $this;
    }

    /**
     * Gets payment_reference
     *
     * @return string
     */
    public function getPaymentReference()
    {
        return $this->container['payment_reference'];
    }

    /**
     * Sets payment_reference
     *
     * @param string $payment_reference The unique identifier in the client system for the payment.
     *
     * @return $this
     */
    public function setPaymentReference($payment_reference)
    {
        $this->container['payment_reference'] = $payment_reference;

        return $this;
    }

    /**
     * Gets expected_payment_settlement_date
     *
     * @return string
     */
    public function getExpectedPaymentSettlementDate()
    {
        return $this->container['expected_payment_settlement_date'];
    }

    /**
     * Sets expected_payment_settlement_date
     *
     * @param string $expected_payment_settlement_date The date on which the payment is expected to be settled with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setExpectedPaymentSettlementDate($expected_payment_settlement_date)
    {
        $this->container['expected_payment_settlement_date'] = $expected_payment_settlement_date;

        return $this;
    }

    /**
     * Gets payment_entry_date
     *
     * @return string
     */
    public function getPaymentEntryDate()
    {
        return $this->container['payment_entry_date'];
    }

    /**
     * Sets payment_entry_date
     *
     * @param string $payment_entry_date The date on which the payment is captured in EBPP. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setPaymentEntryDate($payment_entry_date)
    {
        $this->container['payment_entry_date'] = $payment_entry_date;

        return $this;
    }

    /**
     * Gets payment_return_date
     *
     * @return string
     */
    public function getPaymentReturnDate()
    {
        return $this->container['payment_return_date'];
    }

    /**
     * Sets payment_return_date
     *
     * @param string $payment_return_date The date on which the ACH returns is received by EBPP.
     *
     * @return $this
     */
    public function setPaymentReturnDate($payment_return_date)
    {
        $this->container['payment_return_date'] = $payment_return_date;

        return $this;
    }

    /**
     * Gets return_code
     *
     * @return string
     */
    public function getReturnCode()
    {
        return $this->container['return_code'];
    }

    /**
     * Sets return_code
     *
     * @param string $return_code The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments.
     *
     * @return $this
     */
    public function setReturnCode($return_code)
    {
        $this->container['return_code'] = $return_code;

        return $this;
    }

    /**
     * Gets payment_notification_email
     *
     * @return string
     */
    public function getPaymentNotificationEmail()
    {
        return $this->container['payment_notification_email'];
    }

    /**
     * Sets payment_notification_email
     *
     * @param string $payment_notification_email The email address to which notifications for the payment will be sent. The notifications will be sent to the customer's email in case this is not provided.
     *
     * @return $this
     */
    public function setPaymentNotificationEmail($payment_notification_email)
    {
        $this->container['payment_notification_email'] = $payment_notification_email;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (EBPP) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerResponse
     */
    public function getCustomer()
    {
        return $this->container['customer'];
    }

    /**
     * Sets customer
     *
     * @param \Orbipay\PaymentsApi\Client\Model\SimplePaymentCustomerResponse $customer customer
     *
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->container['customer'] = $customer;

        return $this;
    }

    /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FundingAccountResponse
     */
    public function getFundingAccount()
    {
        return $this->container['funding_account'];
    }

    /**
     * Sets funding_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FundingAccountResponse $funding_account funding_account
     *
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->container['funding_account'] = $funding_account;

        return $this;
    }

    /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse
     */
    public function getCustomerAccount()
    {
        return $this->container['customer_account'];
    }

    /**
     * Sets customer_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse $customer_account customer_account
     *
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->container['customer_account'] = $customer_account;

        return $this;
    }

    /**
     * Gets payment_network_response
     *
     * @return \Orbipay\PaymentsApi\Client\Model\PaymentNetworkResponseVo
     */
    public function getPaymentNetworkResponse()
    {
        return $this->container['payment_network_response'];
    }

    /**
     * Sets payment_network_response
     *
     * @param \Orbipay\PaymentsApi\Client\Model\PaymentNetworkResponseVo $payment_network_response payment_network_response
     *
     * @return $this
     */
    public function setPaymentNetworkResponse($payment_network_response)
    {
        $this->container['payment_network_response'] = $payment_network_response;

        return $this;
    }

    /**
     * Gets audit_info
     *
     * @return \Orbipay\PaymentsApi\Client\Model\AuditInfoVo
     */
    public function getAuditInfo()
    {
        return $this->container['audit_info'];
    }

    /**
     * Sets audit_info
     *
     * @param \Orbipay\PaymentsApi\Client\Model\AuditInfoVo $audit_info audit_info
     *
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->container['audit_info'] = $audit_info;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


