<?php

/**
 * FundingAccounts
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */



/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * FundingAccounts Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client\Wrappers
 */
class FundingAccounts  extends Base 
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'list' => '\Orbipay\PaymentsApi\Client\Wrappers\FundingAccount[]', 
        'total_results_count' => 'string', 
        'has_more_results' => 'string', 
        'url' => 'string', 
        'from_index' => 'string', 
        'to_index' => 'string', 
        'query_id' => 'string', 
        'id_customer' => 'string', 
        'page_size' => 'string', 
        'account_number' => 'string', 
        'status' => 'string[]', 
        'aba_routing_number' => 'string', 
        'account_type' => 'string[]', 
        'account_subtype' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'list' => null,
        'total_results_count' => null,
        'has_more_results' => null,
        'url' => null,
        'from_index' => null,
        'to_index' => null,
        'query_id' => null,
        'id_customer' => null,
        'page_size' => null,
        'account_number' => null,
        'status' => null,
        'aba_routing_number' => null,
        'account_type' => null,
        'account_subtype' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'list' => 'list',
        'total_results_count' => 'total_results_count',
        'has_more_results' => 'has_more_results',
        'url' => 'url',
        'from_index' => 'from_index',
        'to_index' => 'to_index',
        'query_id' => 'query_id',
        'id_customer' => 'ID_CUSTOMER',
        'page_size' => 'page_size',
        'account_number' => 'account_number',
        'status' => 'status',
        'aba_routing_number' => 'aba_routing_number',
        'account_type' => 'account_type',
        'account_subtype' => 'account_subtype'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'list' => 'setList',
        'total_results_count' => 'setTotalResultsCount',
        'has_more_results' => 'setHasMoreResults',
        'url' => 'setUrl',
        'from_index' => 'setFromIndex',
        'to_index' => 'setToIndex',
        'query_id' => 'setQueryId',
        'id_customer' => 'setIdCustomer',
        'page_size' => 'setPageSize',
        'account_number' => 'setAccountNumber',
        'status' => 'setStatus',
        'aba_routing_number' => 'setAbaRoutingNumber',
        'account_type' => 'setAccountType',
        'account_subtype' => 'setAccountSubtype'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'list' => 'getList',
        'total_results_count' => 'getTotalResultsCount',
        'has_more_results' => 'getHasMoreResults',
        'url' => 'getUrl',
        'from_index' => 'getFromIndex',
        'to_index' => 'getToIndex',
        'query_id' => 'getQueryId',
        'id_customer' => 'getIdCustomer',
        'page_size' => 'getPageSize',
        'account_number' => 'getAccountNumber',
        'status' => 'getStatus',
        'aba_routing_number' => 'getAbaRoutingNumber',
        'account_type' => 'getAccountType',
        'account_subtype' => 'getAccountSubtype'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets list
     * @param \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount[] $list list
     * @return $this
     */
    public function setList($list)
    {
        $this->list = $list;

        return $this;
    }

    /**
     * @internal
     * Sets total_results_count
     * @param string $total_results_count The total number of funding accounts of the customer matching the search criteria.
     * @return $this
     */
    public function setTotalResultsCount($total_results_count)
    {
        $this->total_results_count = $total_results_count;

        return $this;
    }

    /**
     * @internal
     * Sets has_more_results
     * @param string $has_more_results true if there are more results or pages
     * @return $this
     */
    public function setHasMoreResults($has_more_results)
    {
        $this->has_more_results = $has_more_results;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the next or previous set of funding accounts, based on the presence of after_object or before_object parameter.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets from_index
     * @param string $from_index The id of the object before which the previous set of objects are to be retrieved.
     * @return $this
     */
    public function setFromIndex($from_index)
    {
        $this->from_index = $from_index;

        return $this;
    }

    /**
     * @internal
     * Sets to_index
     * @param string $to_index The id of the object after which the next set of objects are to be retrieved.
     * @return $this
     */
    public function setToIndex($to_index)
    {
        $this->to_index = $to_index;

        return $this;
    }

    /**
     * @internal
     * Sets query_id
     * @param string $query_id The query id of the object.
     * @return $this
     */
    public function setQueryId($query_id)
    {
        $this->query_id = $query_id;

        return $this;
    }

    /**
     * @internal
     * Sets id_customer
     * @param string $id_customer The unique identifier assigned by EBPP to the customer.
     * @return $this
     */
    public function setIdCustomer($id_customer)
    {
        $this->id_customer = $id_customer;

        return $this;
    }

    /**
     * @internal
     * Sets page_size
     * @param string $page_size The maximum number of objects returned in the query.
     * @return $this
     */
    public function setPageSize($page_size)
    {
        $this->page_size = $page_size;

        return $this;
    }

    /**
     * @internal
     * Sets account_number
     * @param string $account_number The Account Number to get details of.
     * @return $this
     */
    public function setAccountNumber($account_number)
    {
        $this->account_number = $account_number;

        return $this;
    }

    /**
     * @internal
     * Sets status
     * @param string[] $status The status of the funding account in EBPP. This can take multiple values in the format key=value1&key=value2....
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * @internal
     * Sets aba_routing_number
     * @param string $aba_routing_number The ABA/Routing number for the bank account.
     * @return $this
     */
    public function setAbaRoutingNumber($aba_routing_number)
    {
        $this->aba_routing_number = $aba_routing_number;

        return $this;
    }

    /**
     * @internal
     * Sets account_type
     * @param string[] $account_type The type of the funding account. This can take multiple values in the format key=value1&key=value2....
     * @return $this
     */
    public function setAccountType($account_type)
    {
        $this->account_type = $account_type;

        return $this;
    }

    /**
     * @internal
     * Sets account_subtype
     * @param string $account_subtype The sub type of the funding account. This is derived by EBPP in the case of card funding accounts. It needs to be passed when adding or editing a DDA/bank account.
     * @return $this
     */
    public function setAccountSubtype($account_subtype)
    {
        $this->account_subtype = $account_subtype;

        return $this;
    }

    /**
     * @var \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount[] 
     * $list list
     */
    private $list;
  
     /**
     * Gets list
     *
     * @return \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount[] $list list
     */
    public function getList()
    {
        return $this->list;
    }
    /**
     * @var string 
     * $total_results_count The total number of funding accounts of the customer matching the search criteria.
     */
    private $total_results_count;
  
     /**
     * Gets total_results_count
     *
     * @return string $total_results_count The total number of funding accounts of the customer matching the search criteria.
     */
    public function getTotalResultsCount()
    {
        return $this->total_results_count;
    }
        
   /**
     * @var string $has_more_results true if there are more results or pages
     */
    private $has_more_results;
    
    /**
     * Gets has_more_results
     *
     * @return string $has_more_results true if there are more results or pages
     */

    public function getHasMoreResults()
    {
        return $this->has_more_results;
    }
    
    /**
     * @var string 
     * $url This URL fetches the next or previous set of funding accounts, based on the presence of after_object or before_object parameter.
     */
    private $url;
  
     /**
     * Gets url
     *
     * @return string $url This URL fetches the next or previous set of funding accounts, based on the presence of after_object or before_object parameter.
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * @var string 
     * $from_index The id of the object before which the previous set of objects are to be retrieved.
     */
    private $from_index;
  
     /**
     * Gets from_index
     *
     * @return string $from_index The id of the object before which the previous set of objects are to be retrieved.
     */
    public function getFromIndex()
    {
        return $this->from_index;
    }
    /**
     * @var string 
     * $to_index The id of the object after which the next set of objects are to be retrieved.
     */
    private $to_index;
  
     /**
     * Gets to_index
     *
     * @return string $to_index The id of the object after which the next set of objects are to be retrieved.
     */
    public function getToIndex()
    {
        return $this->to_index;
    }
    /**
     * @var string 
     * $query_id The query id of the object.
     */
    private $query_id;
  
     /**
     * Gets query_id
     *
     * @return string $query_id The query id of the object.
     */
    public function getQueryId()
    {
        return $this->query_id;
    }
    /**
     * @var string 
     * $id_customer The unique identifier assigned by EBPP to the customer.
     */
    private $id_customer;
  
     /**
     * Gets id_customer
     *
     * @return string $id_customer The unique identifier assigned by EBPP to the customer.
     */
    public function getIdCustomer()
    {
        return $this->id_customer;
    }
    /**
     * @var string 
     * $page_size The maximum number of objects returned in the query.
     */
    private $page_size;
  
     /**
     * Gets page_size
     *
     * @return string $page_size The maximum number of objects returned in the query.
     */
    public function getPageSize()
    {
        return $this->page_size;
    }
    /**
     * @var string 
     * $account_number The Account Number to get details of.
     */
    private $account_number;
  
     /**
     * Gets account_number
     *
     * @return string $account_number The Account Number to get details of.
     */
    public function getAccountNumber()
    {
        return $this->account_number;
    }
        
   /**
     * @var string[] $status The status of the funding account in EBPP. This can take multiple values in the format key=value1&key=value2....
     */
    private $status;
    
    /**
     * Gets status
     *
     * @return string[] $status The status of the funding account in EBPP. This can take multiple values in the format key=value1&key=value2....
     */

    public function getStatus()
    {
        return $this->status;
    }
    
    /**
     * @var string 
     * $aba_routing_number The ABA/Routing number for the bank account.
     */
    private $aba_routing_number;
  
     /**
     * Gets aba_routing_number
     *
     * @return string $aba_routing_number The ABA/Routing number for the bank account.
     */
    public function getAbaRoutingNumber()
    {
        return $this->aba_routing_number;
    }
        
   /**
     * @var string[] $account_type The type of the funding account. This can take multiple values in the format key=value1&key=value2....
     */
    private $account_type;
    
    /**
     * Gets account_type
     *
     * @return string[] $account_type The type of the funding account. This can take multiple values in the format key=value1&key=value2....
     */

    public function getAccountType()
    {
        return $this->account_type;
    }
    
        
   /**
     * @var string $account_subtype The sub type of the funding account. This is derived by EBPP in the case of card funding accounts. It needs to be passed when adding or editing a DDA/bank account.
     */
    private $account_subtype;
    
    /**
     * Gets account_subtype
     *
     * @return string $account_subtype The sub type of the funding account. This is derived by EBPP in the case of card funding accounts. It needs to be passed when adding or editing a DDA/bank account.
     */

    public function getAccountSubtype()
    {
        return $this->account_subtype;
    }
    

    
       
    public function forClient($client_key = null)
    {
		parent::forClient($client_key);
        
        return $this; 
    }
    public function videChannel($channel = null)
    {
		parent::videChannel($channel);
        
        return $this; 
    }
    public function findBy(MultiMap $filterMap = null)
    {
        
        
		$aba_routing_number_values = $filterMap->get('aba_routing_number');
		if ($aba_routing_number_values !== null && count($aba_routing_number_values) > 0) {
        	$this->aba_routing_number = end($aba_routing_number_values);
		}
        
		$account_type_values = $filterMap->get('account_type');
		if ($account_type_values !== null) {
        	$this->account_type = array_unique($account_type_values);
    	}
            	
        
        
		$account_subtype_values = $filterMap->get('account_subtype');
		if ($account_subtype_values !== null && count($account_subtype_values) > 0) {
        	$this->account_subtype = end($account_subtype_values);
		}
        
        
		$account_number_values = $filterMap->get('account_number');
		if ($account_number_values !== null && count($account_number_values) > 0) {
        	$this->account_number = end($account_number_values);
		}
        
		$status_values = $filterMap->get('status');
		if ($status_values !== null) {
        	$this->status = array_unique($status_values);
    	}
            	
        
        
		$page_size_values = $filterMap->get('page_size');
		if ($page_size_values !== null && count($page_size_values) > 0) {
        	$this->page_size = end($page_size_values);
		}
        
        
		$query_id_values = $filterMap->get('query_id');
		if ($query_id_values !== null && count($query_id_values) > 0) {
        	$this->query_id = end($query_id_values);
		}
        
        
		$from_index_values = $filterMap->get('from_index');
		if ($from_index_values !== null && count($from_index_values) > 0) {
        	$this->from_index = end($from_index_values);
		}
        
        
		$to_index_values = $filterMap->get('to_index');
		if ($to_index_values !== null && count($to_index_values) > 0) {
        	$this->to_index = end($to_index_values);
		}
        
        return $this; 
    }
    public function forCustomer($id_customer = null)
    {
        			$this->id_customer = $id_customer;
        		
        

        
        return $this; 
    }
    
	/**
     * retrievedBy
     *
     * @param $requestor
     * @param $requestor_type
     * @return FundingAccounts
     */
    public function retrievedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    
	/**
     * get
     *
     * @param InvocationContext $invocationContext
     * @param string $liveMode
     * @param string $apiEndPoint
     * @return FundingAccounts
     * @throws OrbipayApiException
     */
    public function get(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\RetrieveFundingAccountsHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
	/**
     * getPage
     *
     * @param InvocationContext $invocationContext
     * @param string $liveMode
     * @param string $apiEndPoint
     * @return FundingAccounts
     * @throws OrbipayApiException
     */
    public function getPage(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\RetrieveFundingAccountsPageHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) , parent::jsonSerialize());
    }
}


